/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.PegawaiDto;
import com.portofolio.service.PegawaiService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/pegawai")
public class PegawaiController extends LocaleController {
    @Lazy
	@Autowired
    private PegawaiService pegawaiService;
    
    
    @ApiOperation("Api Untuk Menyimpan Pegawai")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody PegawaiDto entity,HttpServletRequest request) {
        Map<String, Object> result = pegawaiService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update Pegawai")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdPegawai", required = true) String kdPegawai,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody PegawaiDto entity, HttpServletRequest request) {
        Map<String, Object> result = pegawaiService.update(entity,kdPegawai,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus Pegawai Berdasarkan KdPegawai")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdPegawai", required = true) String kdPegawai,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = pegawaiService.deleteById(kdPegawai, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua Pegawai")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaLengkap") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaPegawai", required = false) String namaPegawai,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = pegawaiService.grid(page, rows, sort, dir, namaPegawai,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Pegawai Berdasarkan kdPegawai")
    @GetMapping("/findByKdPegawai")
    public ResponseEntity<Map<String, Object>> findByKdPegawai(
    		@RequestParam(value = "kdPegawai", required = true) String kdPegawai, 
    		HttpServletRequest request) {
        Map<String, Object> result = pegawaiService.findByKdPegawai(kdPegawai);
        return RestUtil.getJsonResponse(result);
    }


}
